  /*   */
  /*  STRING MATCHING */

  #include <conio.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <dos.h>

  #define MAX(a,b) ((a)>(b)?(a):(b))
  #define REHASH(a,b,h) ((((h)-(a)*(d))<<1)+(b))
  #define ASIZE 128

  int menu();
  void hicolor();
  void norcolor();
  void printpart(char *,int,int);
  void read();
  void den(int,char *);
  void BF(char *,char *,int,int,int);
  void KMP1(char *,int,int []);
  void KMP2(char *,char *,int,int,int);
  void d1(char *,int,int []);
  void d2(char *,int,int[]);
  void BM(char *,char *,int,int,int);
  void RK(char *,char *,int,int,int);
  void (*sinartisi)(char *,char *,int,int,int);

  int z,n,m,u,l,li;
  FILE *arxeio;
  char t[80],p[60];


  main()
   {
    char onoma[60],*c,y;
    int l,g;


    etiketa:l=menu();
    clrscr();
    switch (l) {
      case 1:sinartisi=BF;
	     break;
      case 2:sinartisi=KMP2;
	     break;
      case 3:sinartisi=BM;
	     break;
      case 4:sinartisi=RK;
	     break;
      case 5:read();
	     goto etiketa;
      case 6:close(arxeio);
	     exit(EXIT_SUCCESS);
	     break;
     }
    gotoxy(6,4);
    printf("驜  path  妬:");
    gets(onoma);
    if ((arxeio=fopen(onoma,"r"))==NULL)
     {
      printf("  !! ");
      getch();
      goto etiketa;
     }
    printf("     驜  磜 ⥞ :");
    gets(p);
    printf("     ⢜ ᤠ  槦 㫞; (N) () \n");
    y=getch();
    if (y=='N' || y=='n' || y=='' || y=='')
      u=1;
    else
      u=0;
    z=0;
     do
      {
	c=fgets(t,80,arxeio);
	if (c!=NULL)
	 {
	  z++;
	  n=strlen(t);
	  m=strlen(p);
	  (*sinartisi)(t,p,n,m,z);
	 }
	}
      while (c!=NULL);
      u=0;
      den(li,p);
       goto etiketa;

     fclose(arxeio);
   }

  void hicolor()
  {
    textattr(BLUE + (LIGHTGRAY << 4));
  }

  void norcolor()
  {
    textattr(LIGHTGRAY);
  }

  void printpart(char* t, int ss, int se)
  {
    int i;
    char* k = t;
    norcolor();
    for (i = 0 ; i < ss ; i++, k++) cprintf("%c",*k);
    hicolor();
    for (i = ss ; i < se ; i++, k++) cprintf("%c",*k);
    norcolor();
    cprintf("%s",k);
  }

  void read()
   {
    FILE *f1;
    char *e,*g;
    int counter;

    clrscr();
    f1=fopen("a:\help.txt","r");
    counter=0;
    do
     {
       g=fgets(e,80,f1);
       printf("%s\n",e);
       counter++;
       if (counter==13)
	{
	 hicolor();
	 cprintf("圩 ENTER  ⮜");
	 norcolor();
	 getch();
	 clrscr();
	 counter=0;
	}
      }
      while (g!=NULL);
   }

  void den(int li,char *p)
   {
    if (li!=1)
     {
      clrscr();
      hicolor();
      gotoxy(10,15);
      cprintf("  %s  ⟞  \n",p);
      norcolor();
      li=0;
      getch();
     }
   }

  int menu()
   {
     int x;


     do
      {
       clrscr();
       gotoxy(10,7);
       printf("  MO    ;\n\n");
       printf("         1.BRUTE-FORCE ALGORITHM\n\n");
       printf("         2.KNUTH-MORRIS-PRATT ALGORITHM\n\n");
       printf("         3.BOYER-MOORE ALGORITHM\n\n");
       printf("         4.RABIN-KARP\n\n");
       printf("         5.    \n\n");
       printf("         6.\n\n");
       printf("          :");
       gets(t);
       x=atoi(t);
      }
     while ((x<1)||(x>6));
   return x;
   }

   /* BRUTE-FORCE ALGORITHM */

   void BF(char *t,char *p,int n,int m,int z)
    {
     int i,j;

     i=j=0;
     while (i<=n-m)
      {
       if (p[j]==t[i])
	{
	 i++;
	 j++;
	}
       else
	{
	 i=i-j+1;
	 if (u==1)
	  {
	   clrscr();
	   gotoxy(1,5);
	   printpart(t,i-1,i+m-1);
	   gotoxy(i,6);
	   cprintf("%s",p);
	   delay(300);
	  }
	 j=0;
	}
       if (j>m-1)
	{
	 if (u==1)
	  {
	   clrscr();
	   gotoxy(1,5);
	   printpart(t,i-m,i);
	   gotoxy(i-m+1,6);
	   cprintf("%s\n",p);
	  }
	 hicolor();
	 cprintf(" %s ⟞   %d   ⩞ %d\n ",p,z,i-m+1);
	 norcolor();
	 li=1;
	 getch();
	}
      }
    }

    /* END */

    /* KNUTH-MORRIS-PRATT ALGORITHM */

    void KMP1(char *p,int m,int next[])
     {
      int i,j;

      i=0;
      j=next[0]=-1;
      while (i<m)
       {
	while ((j>-1)&&(p[i]!=p[j]))
	 j=next[j];
	i++;
	j++;
	if (p[i]==p[j])
	 next[i]=next[j];
	else
	 next[i]=j;
       }
     }

    void KMP2(char *t,char *p,int n,int m,int z)
     {
      int i,j,next[60]; /*xsize*/

      KMP1(p,m,next);
      i=j=0;
      while (i<n-1)
       {
	while ((j>-1)&&(p[j]!=t[i]))
	 j=next[j];


	 if ((u==1)&&(p[j]!=t[i])&&(i<n-m))
	 {
	   clrscr();
	   gotoxy(1,5);
	   printpart(t,i,i+m);
	   gotoxy(i+1,6);
	   cprintf("%s",p);
	   delay(300);
	 }
	 i++;
	 j++;
	if (j>m-1)
	 {
	  if ((u==1)&(i<=n-m))
	   {
	    clrscr();
	    gotoxy(1,5);
	    printpart(t,i-m,i);
	    gotoxy(i-m+1,6);
	    cprintf("%s\n",p);
	   }
	  hicolor();
	  cprintf(" %s ⟞   %d  ⩞ %d\n",p,z,i-m+1);
	  norcolor();
	  j=next[j];
	  li=1;
	  getch();
	 }
       }
     }

     /* END */

    /* BOYER-MOORE ALGORITHM */

    void d1(char *p,int m,int delta1[])
     {
      int w,j;

      for (w=0;w<ASIZE;w++)
       delta1[w]=m;
      for (j=0;j<m;j++)
       delta1[p[j]]=m-j-1;
     }

    void d2(char *p,int m,int delta2[])
     {
      int i,j,pat,f[60];  /*xsize*/

      memset(delta2,0,(m+1)*sizeof(int));
      f[m]=j=m+1;
      for (i=m;i>0;i--)
       {
	while ((j<=m)&&(p[i-1]!=p[j-1]))
	 {
	  if (delta2[j]==0)
	   delta2[j]=j-1;
	  j=f[j];
	 }
	f[i-1]=--j;
       }
      pat=f[0];
      for (j=0;j<=m;++j)
       {
	if (delta2[j]==0)
	 delta2[j]=pat;
	if (j==pat)
	 pat=f[pat];
       }
     }

    void BM(char *t,char *p,int n,int m,int z)
     {
      int i,j,delta1[ASIZE],delta2[60]; /*xsize*/

      for (i=0;i<ASIZE;i++)
	delta1[i]=0;
      for (i=0;i<n;i++)
	delta2[i]=0;
      d1(p,m,delta1);
      i=j=m-1;
      while ((j>0)&&(i<=n-m))
       {
	if ((u==1)&&(t[i]!=p[j]))
	  {
	   clrscr();
	   gotoxy(1,5);
	   printpart(t,i-m+1,i+1);
	   gotoxy(i-m+2,6);
	   cprintf("%s",p);
	   delay(300);
	  }
	if (t[i]==p[j])
	 {
	  i--;
	  j--;
	 }
	else
	 {
	  i=i+MAX(delta1[t[i]],delta2[j+1]);
	  j=m-1;
	 }


      if (j<1)
       {
       if (u==1)
	  {
	    clrscr();
	    gotoxy(1,5);
	    printpart(t,i,i+m);
	    gotoxy(i+1,6);
	    cprintf("%s\n",p);
	  }
       hicolor();
       cprintf(" %s ⟞   %d   ⩞ %d\n",p,z,i+1);
       norcolor();
       li=1;
       getch();
       }
      }
    }

    /* END */

    /* RABIN-KARP ALGORITHM*/

    void RK(char *t,char *p,int n,int m,int z)
     {
      unsigned int ht,hp,d,i;

      d=1;
      for (i=1;i<m;i++)
       d=(d<<1);
      ht=hp=0;
      for (i=0;i<m;i++)
       {
	hp=((hp<<1)+p[i]);
	ht=((ht<<1)+t[i]);
       }
      for (i=m;i<n;i++)
       {
	if ((ht==hp)&&(memcmp(&t[i-m],p,m)==0))
	 {
	   if (u==1)
	    {
	     clrscr();
	     gotoxy(1,5);
	     printpart(t,i-m,i);
	     gotoxy(i-m+1,6);
	     cprintf("%s\n",p);
	    }
	   hicolor();
	   cprintf(" string ⟞   %d   ⩞ %d\n",z,i-m+1);
	   norcolor();
	   li=1;
	   getch();
	 }
	ht=REHASH(t[i-m],t[i],ht);
	if (u==1)
	  {
	   clrscr();
	   gotoxy(1,5);
	   printpart(t,i-m,i);
	   gotoxy(i-m+1,6);
	   cprintf("%s",p);
	   delay(300);
	  }
       }
     }

    /* END */


